/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Type, Point_$type, runOn, typeCast, markType } from "igniteui-react-core/ES2015/type";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
/**
 * @hidden
 */
export class HorizontalRangeCategorySeries extends RangeCategorySeries {
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    hn() {
        super.hn();
        this.xAxis = null;
        this.yAxis = null;
    }
    ah(a) {
        let b = this.aj(this.mz(), this.m0.f, this.n0(this.bi), this.n1(this.bi), this.lh(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    }
    ai(a) {
        let b = this.aj(this.mz(), this.m0.f, this.n0(this.bi), this.n1(this.bi), this.lh(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    get_c3() {
        return true;
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    getOffsetValue() {
        return this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.xAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    e9(a, b) {
        return this.fa(a, b, this.xAxis, runOn(this, this.ny), new RangeValueList(this.highColumn, this.lowColumn));
    }
    fb(a, b) {
        return this.fc(a, b, this.xAxis, runOn(this, this.ny), new RangeValueList(this.highColumn, this.lowColumn));
    }
    d6(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.xAxis.jr;
        return this.d7(a, b, this.xAxis, d, e, f, runOn(this, this.ny));
    }
    ek(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mq, this.bi.br, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mq, this.bi.br, d);
        return this.em(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.ny), b, c);
    }
    ei(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mq, this.bi.br, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mq, this.bi.br, d);
        return this.em(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.ny), b, c);
    }
    eg(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mq, this.bi.br, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mq, this.bi.br, d);
        return this.em(this.highColumn, a, this.xAxis, e, f, runOn(this, this.ny), b, c);
    }
    la(a, b, c) {
        return this.lg(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.eg), (d, e) => this.fc(d, e, this.xAxis, runOn(this, this.ny), this.highColumn), (d, e) => this.fa(d, e, this.xAxis, runOn(this, this.ny), this.highColumn));
    }
    lc(a, b, c) {
        return this.lg(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ei), (d, e) => this.fc(d, e, this.xAxis, runOn(this, this.ny), this.lowColumn), (d, e) => this.fa(d, e, this.xAxis, runOn(this, this.ny), this.lowColumn));
    }
    le(a, b, c) {
        return this.lg(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, null, null, null);
    }
    nu() {
        return this.yAxis != null && this.yAxis.ck();
    }
    is(a, b, c, d) {
        super.is(a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.ht(typeCast(Axis.$, c));
                this.ix(typeCast(Axis.$, d));
                this.m8.cn.g(this.er);
                this.i6(false);
                this.ic();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.ht(typeCast(Axis.$, c));
                this.ix(typeCast(Axis.$, d));
                this.m8.cn.g(this.er);
                this.nu();
                this.i6(false);
                this.ic();
                break;
        }
    }
    o7(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    o6(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.nv;
    }
}
HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::pa', [CategoryAxisBase.$, null], 'YAxis::pb', [NumericYAxis.$, null]]);
